import 'package:davison/davison.dart';
import 'package:test/test.dart';

import 'product.dart';

main() {
  test('serialize simple object & deserialize', () {
    var product = Product();
    product.name = 'Apple';
    product.expiry = DateTime(2019, 12, 31, 14, 12, 42, 332);

    String json = Davison.toJson(product);
    expect(json, '{"name":"Apple","expiry":"2019-12-31 14:12:42.332"}');

    Product fromJson = Davison.fromJson(json);
    expect(fromJson.name, product.name);
    expect(fromJson.expiry, product.expiry);
  });

  test('serialize simple list', () {
    var products = List<Product>();
    products.add(Product('Apple', DateTime(2008, 1, 2, 4, 5, 23, 223)));
    products.add(Product('Banana', DateTime(2013, 11, 30, 1, 11, 3, 234)));
    products.add(Product('Citrus', DateTime.now()));

    String json = Davison.toJson(products);
    expect(json, '[{"name":"Apple","expiry":"2008-01-02 04:05:23.223"},{"name":"Banana","expiry":"2013-11-30 01:11:03.234"},{"name":"Citrus","expiry":"${products[2].expiry}"}]');

    List<Product> fromJson = Davison.fromJson(json);
    for (var i=0; i < fromJson.length; i++) {
      expect(fromJson[i].name, products[i].name);
      expect(fromJson[i].expiry, products[i].expiry);
    }
  });
}
  
